#!/bin/sh
#
# Build modules under Ubuntu-20.04 LTS for TechnoTrend DVB S2-6400
# Based on https://www.vdr-portal.de/forum/index.php?thread/132415-tt-s2-6400-saa716x-kompilieren-unter-18-04/&postID=1337903#post1337903
#

URL=https://github.com/s-moch/linux-saa716x/compare
BUILDDIR=~/linux-saa716x
LOGFILE=$BUILDDIR/linux-saa716x.log
KERNELVERSION=$(uname -r)
KMAJOR=$(uname -r | cut -d'.' -f1)
KMINOR=$(uname -r | cut -d'.' -f2)
KSOURCE=$(uname -r | cut -d'-' -f1)
DIFF=saa716x-$KMAJOR.$KMINOR.diff
sudo apt install fakeroot build-essential devscripts libncurses5 libncurses5-dev bison flex libssl-dev pv wget linux-source-$KSOURCE linux-headers-$KERNELVERSION
rm -rf $BUILDDIR
mkdir -p $BUILDDIR
cd $BUILDDIR
wget $URL/$DIFF
echo "Kernel Sources entpacken..." 
pv /usr/src/linux-source-$KSOURCE.tar.bz2 | bzip2 -d | tar x
cd linux-source-$KSOURCE
cp /boot/config-$KERNELVERSION .config
cp /usr/src/linux-headers-$KERNELVERSION/Module.symvers .
printf "#\n# Kernelversion: $KERNELVERSION\n#\n" >$LOGFILE
patch -p1 < ../$DIFF | tee -a $LOGFILE
printf "y\nm\nm\nm\nm\n" | make oldconfig | tee -a $LOGFILE
make KERNELVERSION=$KERNELVERSION -j6 modules_prepare | tee -a $LOGFILE
make KERNELVERSION=$KERNELVERSION -j6 M=drivers/media/pci/saa716x/ modules | tee -a $LOGFILE
sudo cp drivers/media/pci/saa716x/saa716x_core.ko /lib/modules/$KERNELVERSION/kernel/drivers/media/pci/
sudo cp drivers/media/pci/saa716x/saa716x_ff.ko /lib/modules/$KERNELVERSION/kernel/drivers/media/pci/
sudo depmod $KERNELVERSION

